#ifndef CNTXT_H__
#define CNTXT_H__

/* FIXME: for testing only - use configure later */
#define HAVE_POSIX_SETJMP

#include <Rinternals.h>

/* -- hack to get at the current call from C code using contexts */
#include <setjmp.h>

/* stuff we need to pull for Windows... */
#ifdef WIN32
/* this is from gnuwin32/fixed/h/psignal.h */
#ifndef _SIGSET_T_
#define _SIGSET_T_
typedef int sigset_t;
#endif  /* Not _SIGSET_T_ */
typedef struct
{
  jmp_buf jmpbuf;     /* Calling environment.  */
  int mask_was_saved;       /* Saved the signal mask?  */
  sigset_t saved_mask;      /* Saved signal mask.  */
} sigjmp_buf[1];
/* we need to set HAVE_POSIX_SETJMP since we don't have config.h on Win */
#ifndef HAVE_POSIX_SETJMP
#define HAVE_POSIX_SETJMP
#endif
#endif /* WIN32 */

#ifdef HAVE_POSIX_SETJMP
#define JMP_BUF sigjmp_buf
#else
#define JMP_BUF jmp_buf
#endif

#ifndef CTXT_BUILTIN
#define CTXT_BUILTIN 64
#endif
#ifndef CTXT_CCODE
#define CTXT_CCODE 8
#endif

typedef struct RCNTXT { /* this RCNTXT structure is only partial since we need to get as far as cenddata */
  struct RCNTXT *nextcontext; /* The next context up the chain */
  int callflag;               /* The context "type" */
  JMP_BUF cjmpbuf;            /* C stack and register information */
  int cstacktop;              /* Top of the pointer protection stack */
  int evaldepth;              /* evaluation depth at inception */
  SEXP promargs;              /* Promises supplied to closure */
  SEXP callfun;               /* The closure called */
  SEXP sysparent;             /* environment the closure was called from */
  SEXP call;                  /* The call that effected this context*/
  SEXP cloenv;                /* The environment */
  SEXP conexit;               /* Interpreted "on.exit" code */
  void (*cend)(void *);       /* C "on.exit" thunk */
  void *cenddata;             /* data for C "on.exit" thunk */
  void *res[16];   /* filler to make sure we allocate enough space
		      for future versions (currently we are at at most
		      8 used slots as of R 2.12.1 */
} RCNTXT;

void Rf_begincontext(RCNTXT*, int, SEXP, SEXP, SEXP, SEXP, SEXP);
void Rf_endcontext(RCNTXT*);

#endif
