#ifndef THREADS_H__
#define THREADS_H__

#ifndef USE_RINTERNALS
#define USE_RINTERNALS 1
#endif
#include <Rinternals.h>

/*---- interface ----*/

typedef struct thread {
  SEXP self; /* R object containing this thread object */
  void (*enter_parallel_region)(SEXP thread);
  void (*leave_parallel_region)(SEXP thread);
  SEXP (*call_return)(SEXP thread, SEXP result);
  void *pt;  /* implementation thread pointer */
  SEXP expr, env; /* arguments for the thread routine */
  SEXP res;  /* result (if present, protected) */
  SEXP prot; /* vector of protected objects */
  int state;
  PROTECT_INDEX top;
  char rcx[512]; /* space for RCNTXT (less than 368 needed in R 2.13.0 so far) */
} thread_t;

#define R_enter_parallel_region(thread) ((thread_t*)EXTPTR_PTR(thread))->enter_parallel_region(thread)
#define R_leave_parallel_region(thread) ((thread_t*)EXTPTR_PTR(thread))->leave_parallel_region(thread)
#define R_thread_return(thread, result) return ((thread_t*)EXTPTR_PTR(thread))->call_return(thread, result)

#endif
